---
title: WebGLRenderingContext.hint()
slug: Web/API/WebGLRenderingContext/hint
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.hint()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> specifies hints for certain behaviors. The interpretation of these hints depend on the implementation.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.hint(<var>target</var>, <var>mode</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>Sets which behavior to be controlled. Possible values:
 <ul>
  <li><code>gl.GENERATE_MIPMAP_HINT</code>: Quality of filtering when generating mipmap images with {{domxref("WebGLRenderingContext.generateMipmap()")}}.</li>
  <li>When using the {{domxref("OES_standard_derivatives")}} extension:
   <ul>
    <li><code>ext.FRAGMENT_SHADER_DERIVATIVE_HINT_OES</code>: Accuracy of the derivative calculation for the GLSL built-in functions: <code>dFdx</code>, <code>dFdy</code>, and <code>fwidth</code>.</li>
   </ul>
  </li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.FRAGMENT_SHADER_DERIVATIVE_HINT</code>: Same as <code>ext.FRAGMENT_SHADER_DERIVATIVE_HINT_OES</code></li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>mode</dt>
 <dd>Sets the behavior. The default value is <code>gl.DONT_CARE</code>. The possible values are:
 <ul>
  <li><code>gl.FASTEST</code>: The most efficient behavior should be used.</li>
  <li><code>gl.NICEST</code>: The most correct or the highest quality option should be used.</li>
  <li><code>gl.DONT_CARE</code>: There is no preference for this behavior.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<p>The following example hints that the quality of filtering when generating mipmap images should be most efficient instead of best quality.</p>

<pre class="brush: js">gl.hint(gl.GENERATE_MIPMAP_HINT, gl.FASTEST);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.3", "hint")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glHint.xml", "glHint")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.hint")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.generateMipmap()")}}</li>
 <li>{{domxref("OES_standard_derivatives")}}</li>
</ul>
